<?php
// Gallery's common functions
function get_msgs()
{
	return array(
		'en' => array(
			'ssl_dir'	=> 'Install application to "http://" or "https://" virtual host?',
			'ssl_on'	=> 'https',
			'ssl_off'	=> 'http',
			'install_prefix' => 'Destination directory',
			'configuration' => 'Configuration',
			'installation' => 'Configuration',
			'safe_mode'	=>	'You must disable SAFE MODE in your php configuration to working with gallery',
        'gallery2_dbname'               => 'Database name',
        'gallery2_dbuser'               => 'Database login',
        'gallery2_dbpasswd'             => 'Password',
        'gallery2_dbconfirm'            => 'Confirm password',
        'database_preferences'          => 'Database preferences',
        'administrator_preferences'     => 'Administrator\'s preferences',
        'invalid_values' => 'You have specified incorrect parameters.',

			'safe_mode_label'	=>	'Warning:',
			'admin_login' => 'The username that will be used to authenticate you in Gallery',
			'admin_fullname' => 'Full user name that will be displayed in Gallery',
			'admin_passwd' => 'The password that will be used to authenticate you in Gallery',
			'admin_confirm' => 'The same password as above for verification',
			'admin_email' => 'Admin email that will be displayed in Gallery',
			'gallery_name' => 'Your Gallery name',
			'password__not_match' => 'Passwords do not match.',
			'password__empty' => 'Please enter non-empty password.',
			'locale' => 'Locale that will be used in Gallery',
			'installation_directory_already_exists'     => 'Installation directory already exists',
				
			
			//error messages
			'invalid_value'	=> 'Incorrect value.'
			
		),

		'de' => array(
		)
	);
}

function msg($name)
{
	static $locale;
	if (!isset($locale))
		$locale = sapp_get_locale();
	$def_locale = 'en';
	static $messages;
	if (!isset($messages)) {
		$messages = get_msgs();
	}
	if (isset($messages[$locale][$name]))
		return $messages[$locale][$name];
	else if (isset($messages[$def_locale][$name]))
		return $messages[$def_locale][$name];
	else return 
		$name;
}

/**
 * Check that required parameter is set. $additional_check may specify validity-checking
 * function name.
 * If parameter is set and valid - register it and return true.
 * If parameter is set but not valid - register it, mark as erroneous and return false.
 * If parameter is not set - mark it as erroneous and return false.
 *
 * @param $param_name string
 * @param $additional_check string
 * @return boolean
 */
function check_and_set_required($param_name, $additional_check = '') 
{
	$value = sapp_get_submit_value($param_name);

	// check that required parameter is set
	if (null === $value) {
		sapp_set_wrong($param_name);
		return false;
	}

	// parameter is specifyed - save it's value anyway
	sapp_set_param($param_name, $value);

	// check parameter's validity if validity-checking function is specifyed
	if ($additional_check !== '') {

		// check for validity-checking function existence
		if (!function_exists($additional_check)) {
			sapp_set_errormsg('Can\'t check parameter\'s "' . $param_name . '" validity: function "' . $additional_check . '" doesn\'t exist');
			sapp_set_wrong($param_name);
			return false;
		}

		// check parameter's validity
		if (!$additional_check($value)) {
			sapp_set_wrong($param_name, msg('invalid_value'));
			return false;
		}
	}

	// all checks done, parameter is specifyed and seems to be correct
	return true;
}

/**
 * Check if optional parameter is set. $additional check may specify validity-checking
 * function name.
 * If parameter is set and valid - register it and return true.
 * If parameter is set but not valid - mark it as erroneous and return false.
 * If parameter is not set - unregister it and return true.
 *
 * @param $param_name string
 * @param $additional_check string
 * @return boolean
 */
function check_and_set_optional($param_name, $additional_check = '') 
{
	$value = sapp_get_submit_value($param_name);

	// check if optional parameter is not set
	if (null === $value) {
		sapp_set_param($param_name, NULL);
		return true;
	}

	// parameter is specifyed - save it's value anyway
	sapp_set_param($param_name, $value);

	// check parameter's validity if validity-checking function is specifyed
	if ($additional_check !== '') {

		// check for validity-checking function existence
		if (!function_exists($additional_check)) {
			sapp_set_errormsg('Can\'t check parameter\'s "' . $param_name . '" validity: function "' . $additional_check . '" doesn\'t exist');
			sapp_set_wrong($param_name);
			return false;
		}

		// check parameter's validity
		if (!$additional_check($value)) {
			sapp_set_wrong($param_name);
			return false;
		}
	}

	// all checks done, parameter is specifyed and seems to be correct
	return true;
}
?>
